/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jemu.system.cpc;

/**
 *
 * @author Markus
 */

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.UnsupportedAudioFileException;

import java.io.*;
import java.util.zip.*;

/**
 *
 *
 */
public class WavToByte {


  private AudioFormat format;


  /**
   * Opens a sound from a file.
   */
  public WavToByte(String filename) {
    try {
     CPC.tapesample = new byte[0];
    InputStream result;
   
      result = new FileInputStream(filename);
    if (filename.toLowerCase().endsWith(".zip") || filename.toLowerCase().endsWith(".jtp")) {
      ZipInputStream str = new ZipInputStream(result);
      str.getNextEntry();
      result = str;
    }
      AudioInputStream stream = AudioSystem.getAudioInputStream(result);

      format = stream.getFormat();

      // get the audio samples
      getSamples(stream);
    } catch (UnsupportedAudioFileException ex) {
      ex.printStackTrace();
    } catch (IOException ex) {
      ex.printStackTrace();
    }
    System.out.println("Format: " + format);
  }


  /**
   * Gets the samples from an AudioInputStream as an array of bytes.
   */
  private void getSamples(AudioInputStream audioStream) {
    // get the number of bytes to read
    int length = (int) (audioStream.getFrameLength() * format.getFrameSize());

    // read the entire stream
    CPC.tapesample = new byte[length];
    DataInputStream is = new DataInputStream(audioStream);
    try {
      is.readFully(CPC.tapesample);
    } catch (IOException ex) {
      ex.printStackTrace();
    }
  }
}


